// CodeGear C++Builder
// Copyright (c) 1995, 2011 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'FlexPath.pas' rev: 23.00 (Win32)

#ifndef FlexpathHPP
#define FlexpathHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Winapi.Windows.hpp>	// Pascal unit
#include <System.Classes.hpp>	// Pascal unit
#include <FlexUtils.hpp>	// Pascal unit
#include <System.Types.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Flexpath
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TPointType : unsigned char { ptNode, ptEndNode, ptEndNodeClose, ptControl };
#pragma option pop

typedef System::DynamicArray<System::Types::TPoint> TPointArray;

typedef System::DynamicArray<TPointType> TPointTypeArray;

typedef System::DynamicArray<bool> TSelectedArray;

typedef System::DynamicArray<System::Types::TRect> TRectArray;

#pragma option push -b-
enum TPathEditFunc : unsigned char { pfOffset, pfJoin, pfBreak, pfClose, pfToLine, pfToCurve };
#pragma option pop

typedef System::Set<TPathEditFunc, TPathEditFunc::pfOffset, TPathEditFunc::pfToCurve>  TPathEditFuncs;

struct TPathEditParams;
typedef TPathEditParams *PPathEditParams;

struct DECLSPEC_DRECORD TPathEditParams
{
	
public:
	System::Types::TPoint Offset;
	bool MoveControls;
};


struct TNearestPoint;
typedef TNearestPoint *PNearestPoint;

struct DECLSPEC_DRECORD TNearestPoint
{
	
public:
	System::Types::TPoint Point;
	int Index0;
	int Index1;
	int MinIndex;
	float MinSqrDist;
	float CurvePos;
	bool IsNewMin;
};


struct TPathFigureInfo;
typedef TPathFigureInfo *PPathFigureInfo;

struct DECLSPEC_DRECORD TPathFigureInfo
{
	
public:
	int FirstNode;
	int LastNode;
	int LastPoint;
	bool IsClosed;
	bool IsCurve;
};


typedef System::DynamicArray<TPathFigureInfo> TPathFigureInfos;

struct TPathInfo;
typedef TPathInfo *PPathInfo;

struct DECLSPEC_DRECORD TPathInfo
{
	
public:
	int PointCount;
	bool IsCurve;
	TPathFigureInfos Figures;
};


#pragma option push -b-
enum TRerouteMode : unsigned char { rmAlways, rmAsNeeded, rmNever };
#pragma option pop

struct TRerouteParams;
typedef TRerouteParams *PRerouteParams;

struct DECLSPEC_DRECORD TRerouteParams
{
	
public:
	System::Types::TRect RangeA;
	System::Types::TRect RangeB;
	TRerouteMode Mode;
	bool Ortogonal;
	int LinkMinGap;
	bool SelfLink;
	System::Types::TPoint LinkPointA;
	System::Types::TPoint LinkPointB;
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE bool __fastcall PointOnLine(const System::Types::TPoint &p, const System::Types::TPoint &p0, const System::Types::TPoint &p1, int StrokeWidth, System::Classes::TList* ScanLinePoints = (System::Classes::TList*)(0x0), PNearestPoint Nearest = (PNearestPoint)(0x0));
extern PACKAGE bool __fastcall CalcPath(const TPointArray Points, const TPointTypeArray Types, System::Types::TRect &Range, PPathInfo Info = (PPathInfo)(0x0));
extern PACKAGE bool __fastcall CreatePath(HDC DC, const TPointArray Points, const TPointTypeArray Types, bool UseClosed, bool UseNotClosed, bool &Complete, bool OriginalBezier = false, PPathInfo Info = (PPathInfo)(0x0));
extern PACKAGE bool __fastcall PointOnPath(const TPointArray Points, const TPointTypeArray Types, const System::Types::TPoint &Point, bool Stroked, bool Filled, int StrokeWidth = 0x0, PNearestPoint Nearest = (PNearestPoint)(0x0), PPathInfo Info = (PPathInfo)(0x0), Winapi::Windows::PSingle LengthPos = (Winapi::Windows::PSingle)(0x0));
extern PACKAGE float __fastcall PathLength(const TPointArray Points, const TPointTypeArray Types, PPathInfo Info = (PPathInfo)(0x0));
extern PACKAGE bool __fastcall PathLengthPos(const TPointArray Points, const TPointTypeArray Types, float PathPos, PNearestPoint Nearest, PPathInfo Info = (PPathInfo)(0x0));
extern PACKAGE bool __fastcall FlattenPath(TPointArray &Points, TPointTypeArray &Types, float Curvature, PPathInfo Info = (PPathInfo)(0x0));
extern PACKAGE int __fastcall InsertPathPoint(TPointArray &Points, TPointTypeArray &Types, int FirstIndex, int NextIndex, const System::Types::TPoint &Point, int StickThreshold = 0x0, PPathInfo Info = (PPathInfo)(0x0));
extern PACKAGE bool __fastcall FindNearestPathSegment(const TPointArray Points, const TPointTypeArray Types, const System::Types::TPoint &Point, int &FirstIndex, int &NextIndex, PNearestPoint Nearest = (PNearestPoint)(0x0), PPathInfo Info = (PPathInfo)(0x0), bool ForInsert = true);
extern PACKAGE int __fastcall InsertNearestPoint(TPointArray &Points, TPointTypeArray &Types, const System::Types::TPoint &Point, int StickThreshold = 0x0, PPathInfo Info = (PPathInfo)(0x0));
extern PACKAGE TPathEditFuncs __fastcall GetEditPathCaps(const TPointArray Points, const TPointTypeArray Types, const TSelectedArray Selected);
extern PACKAGE bool __fastcall EditPath(TPointArray &Points, TPointTypeArray &Types, const TSelectedArray Selected, TPathEditFunc Func, PPathEditParams Params = (PPathEditParams)(0x0))/* overload */;
extern PACKAGE bool __fastcall EditPath(TPointArray &Points, TPointTypeArray &Types, int const *Indexes, const int Indexes_Size, TPathEditFunc Func, PPathEditParams Params = (PPathEditParams)(0x0))/* overload */;
extern PACKAGE bool __fastcall ConnectorReroute(TPointArray &Points, TPointTypeArray &PointTypes, const TRerouteParams &Params);
extern PACKAGE void __fastcall GetPathInfo(const TPointArray Points, const TPointTypeArray Types, TPathInfo &Info);
extern PACKAGE int __fastcall GetFigureIndex(const TPathInfo &Info, int PointIndex);
extern PACKAGE bool __fastcall ChangePathCount(TPointArray &Points, TPointTypeArray &Types, int Index, int Delta);

}	/* namespace Flexpath */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_FLEXPATH)
using namespace Flexpath;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// FlexpathHPP
